INCLUDE(test/testCommon.cmake)
INCLUDE(ManageMessage)
INCLUDE(ManageZanata)

FUNCTION(ZANATA_PARSE_LOCALE_TEST expLanguage expScript expCountry expModifier expSuggestCountry expSuggestModifier str)
    MESSAGE("ZANATA_PARSE_LOCALE_TEST(${str})")
    ZANATA_PARSE_LOCALE(language script country modifier suggestCountry suggestModifier "${str}")
    TEST_STR_MATCH(language "${expLanguage}")
    TEST_STR_MATCH(script "${expScript}")
    TEST_STR_MATCH(country "${expCountry}")
    TEST_STR_MATCH(modifier "${expModifier}")
    TEST_STR_MATCH(suggestCountry "${expSuggestCountry}")
    TEST_STR_MATCH(suggestModifier "${expSuggestModifier}")
ENDFUNCTION(ZANATA_PARSE_LOCALE_TEST)

ZANATA_PARSE_LOCALE_TEST("fr" "" "" "" "FR" "" "fr")
ZANATA_PARSE_LOCALE_TEST("de" "" "DE"  "" "DE" "" "de_DE")
ZANATA_PARSE_LOCALE_TEST("bem" "" "ZM" "" "ZM" "" "bem_ZM")
ZANATA_PARSE_LOCALE_TEST("zh" "Hans" "" "" "CN" "" "zh-Hans")
ZANATA_PARSE_LOCALE_TEST("zh" "Hant" "" "" "TW" "" "zh-Hant")
ZANATA_PARSE_LOCALE_TEST("zh" "Hant" "TW" "" "TW" "" "zh-Hant-TW")
ZANATA_PARSE_LOCALE_TEST("sr" "Latn" "" "" "RS" "latin" "sr-Latn")
ZANATA_PARSE_LOCALE_TEST("sr" "Cyrl" "" "" "RS" "" "sr-Cyrl")
ZANATA_PARSE_LOCALE_TEST("sr" "" "RS" "latin" "RS" "latin" "sr_RS@latin")
ZANATA_PARSE_LOCALE_TEST("eo" "" "" "" "" "" "eo")
ZANATA_PARSE_LOCALE_TEST("nb" "" "NO" "" "NO"  "" "nb_NO")


FUNCTION(ZANATA_ZANATA_XML_MAP_BETTER_MATCH_TEST expect currentBestMatch serverLocale clientLocale)
    MESSAGE("ZANATA_ZANATA_XML_MAP_BETTER_MATCH_TEST(${expect})")
    ZANATA_ZANATA_XML_MAP_BETTER_MATCH(v "${currentBestMatch}" "${serverLocale}" "${clientLocale}")
    TEST_STR_MATCH(v "${expect}")
ENDFUNCTION(ZANATA_ZANATA_XML_MAP_BETTER_MATCH_TEST)

ZANATA_ZANATA_XML_MAP_BETTER_MATCH_TEST("lt_LT" "lt_LT" "lt" "lv_LV")
ZANATA_ZANATA_XML_MAP_BETTER_MATCH_TEST("fr_FR" "" "fr" "fr_FR")
ZANATA_ZANATA_XML_MAP_BETTER_MATCH_TEST("fr" "fr" "fr" "fr_FR")
ZANATA_ZANATA_XML_MAP_BETTER_MATCH_TEST("zh_CN" "" "zh-Hans" "zh_CN")
ZANATA_ZANATA_XML_MAP_BETTER_MATCH_TEST("zh_TW" "" "zh-Hant-TW" "zh_TW")
ZANATA_ZANATA_XML_MAP_BETTER_MATCH_TEST("zh_TW" "zh-Hant" "zh-Hant-TW" "zh_TW")
ZANATA_ZANATA_XML_MAP_BETTER_MATCH_TEST("zh_TW" "zh-Hant" "zh-TW" "zh_TW")
ZANATA_ZANATA_XML_MAP_BETTER_MATCH_TEST("zh_TW" "zh-Hant-TW" "zh-TW" "zh_TW")
ZANATA_ZANATA_XML_MAP_BETTER_MATCH_TEST("zh_CN" "zh-TW" "zh-Hans" "zh_CN")
ZANATA_ZANATA_XML_MAP_BETTER_MATCH_TEST("sr_RS@latin" "sr_RS" "sr-Latn" "sr_RS@latin")
ZANATA_ZANATA_XML_MAP_BETTER_MATCH_TEST("sr_RS" "sr_RS@latin" "sr-Cyrl" "sr_RS")
ZANATA_ZANATA_XML_MAP_BETTER_MATCH_TEST("sr_RS" "sr_RS" "sr-Cyrl" "sr_RS@latin")
## fr imply fr_FR
ZANATA_ZANATA_XML_MAP_BETTER_MATCH_TEST("fr_FR" "fr_BE" "fr" "fr_FR")
ZANATA_ZANATA_XML_MAP_BETTER_MATCH_TEST("fr_FR" "fr_FR" "fr" "fr_BE")

